<html>
<head>
<title>OgreD3D11HardwareOcclusionQuery.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11HardwareOcclusionQuery.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11HardwareOcclusionQuery_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef _D3D11HARWAREOCCLUSIONQUERY_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define _D3D11HARWAREOCCLUSIONQUERY_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareOcclusionQuery_8h.html">OgreHardwareOcclusionQuery.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Device_8h.html">OgreD3D11Device.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038     <span class="comment">// If you use multiple rendering passes you can test only the first pass and all other passes don&#39;t have to be rendered </span>
<a name="l00039"></a>00039     <span class="comment">// if the first pass results has too few pixels visible.</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041     <span class="comment">// Be sure to render all occluder first and whats out so the RenderQue don&#39;t switch places on </span>
<a name="l00042"></a>00042     <span class="comment">// the occluding objects and the tested objects because it thinks it&#39;s more effective..</span>
<a name="l00043"></a>00043 
<a name="l00053"></a><a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html">00053</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html" title="This is a class that is the DirectX9 implementation of hardware occlusion testing.">D3D11HardwareOcclusionQuery</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055         <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00056"></a>00056         <span class="comment">// Public methods</span>
<a name="l00057"></a>00057         <span class="comment">//--</span>
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00064"></a>00064         <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#af2f609f8488b963340df3c04aedd75d9" title="Default object constructor.">D3D11HardwareOcclusionQuery</a>( <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device );
<a name="l00065"></a>00065 
<a name="l00069"></a>00069         <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#aa91b896bee07d9259104c4f59db2d152" title="Object destructor.">~D3D11HardwareOcclusionQuery</a>();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071         <span class="comment">//------------------------------------------------------------------</span>
<a name="l00072"></a>00072         <span class="comment">// Occlusion query functions (see base class documentation for this)</span>
<a name="l00073"></a>00073         <span class="comment">//--</span>
<a name="l00074"></a>00074 
<a name="l00075"></a>00075         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a25eadd4b2ad1c9c04c4827ee98b52aa2" title="Starts the hardware occlusion query.">beginOcclusionQuery</a>(); 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a058005d6ae302bf8fe312cbfe31c3aae" title="Ends the hardware occlusion test.">endOcclusionQuery</a>();
<a name="l00077"></a>00077         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a21e4304da998fbaa791d9b343b03f294" title="Pulls the hardware occlusion query.">pullOcclusionQuery</a>( <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* NumOfFragments);
<a name="l00078"></a><a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a95818811808f3175c390e6986e1f4f05">00078</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a95818811808f3175c390e6986e1f4f05">getLastQuerysPixelcount</a>() { <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html#ad9ae2ba4b9c5f443a8bb423ddeb6121b">mPixelCount</a>; }
<a name="l00079"></a>00079         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a1d5f33f82af884851ab3e29b7c5cca0c" title="Lets you know when query is done, or still be processed by the Hardware.">isStillOutstanding</a>(<span class="keywordtype">void</span>);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081     
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00084"></a>00084         <span class="comment">// private members</span>
<a name="l00085"></a>00085         <span class="comment">//--</span>
<a name="l00086"></a>00086     <span class="keyword">private</span>:    
<a name="l00087"></a><a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a9c5d7c8b6f5c161bd4af1024b9f5887c">00087</a>         ID3D11Query*    <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#a9c5d7c8b6f5c161bd4af1024b9f5887c">mQuery</a>;
<a name="l00088"></a><a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#accb91d08465a50016e3eef240a363988">00088</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp;   <a class="code" href="classOgre_1_1D3D11HardwareOcclusionQuery.html#accb91d08465a50016e3eef240a363988">mDevice</a>;
<a name="l00089"></a>00089     };
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
